[comment {-*- tcl -*- doctools manpage}]
[vset libname www::proxypac]
[vset cmdname www]
[manpage_begin [vset libname] n 2.0]
[copyright {2021 Schelte Bron}]
[moddesc   {Proxy auto-config for Tcl HTTP client library}]
[titledesc {Proxy auto-config add-on for the www Tcl library}]
[require Tcl 8.6]
[require www 2.0]
[require [vset libname] 2.0]
[see_also www]

[description]
The [package [vset libname]] package adds support for proxy 
auto-configuration (PAC) files to the [package www] package.
After the [package [vset libname]] package has been loaded, the
[option -proxy] configuration option of the [cmd www] command can be
set to "[method proxypac] [arg pacurl]", where [arg pacurl] is the URL of the
Automatic proxy configuration resource.

[para]

A PAC file contains a JavaScript function
[fun FindProxyForURL]([arg url], [arg host]).
If available, the [package duktape] package is used to run the JavaScript
code.
Alternatively, the proxypac module translates the JavaScript code to Tcl to
make repeatedly running it reasonably fast.
As it is not feasible to implement a full JS->Tcl conversion, only a small
subset of JavaScript is supported. But since PAC files don't normally use
very complex code, it should work for most PAC files.
If the conversion fails, the filter defaults to DIRECT. 
[para]
If the simple JS conversion is too limited to properly handle the PAC file,
consider installing the [package duktape] package:
[sectref-external https://github.com/dbohdan/tcl-duktape]
[manpage_end]
